unit EasyMasks;
{---------------------------------------------------------------
쐬ҁFNWs( mine@text2music.com )
쐬F2002/04/11
CF2003/07/26  "s*"  "s" }b`ȂoO

@F

ȒPȃChJ[h̃}b`NX

ChJ[ḧӖ

* Cӂ̕
? Cӂ̂P
----------------------------------------------------------------}

interface
uses
  SysUtils;

type
  TEasyMask = class
  private
    si : Integer; // FStr  ̃CfbNX
    mi : Integer; // FMask ̃CfbNX
    function CheckChar: Boolean;
    function SubMatch : Boolean;
  public
    FStr     : WideString;
    FMask    : WideString;
    function Match : Boolean;
  end;

// Delphi  MatchesMask (啶ʂȂ)
function MatchesMask(const FileName, Masks: string) : Boolean;
//(啶ʂ)
function MatchesMask2(const FileName, Masks: string) : Boolean;

implementation

function MatchesMask2(const FileName, Masks: string) : Boolean;
var
  e: TEasyMask;
begin
  e := TEasyMask.Create ;
  try
    e.FStr  := FileName;
    e.FMask := Masks;
    Result := e.Match ;
  finally
    e.Free ;
  end;
end;

{ TEasyMask }

function TEasyMask.CheckChar: Boolean;
var
  ss, ms: WideChar;
  tsi, tmi, i: Integer;

  procedure Next;
  begin
    Inc(si);
    Inc(mi);
  end;

  procedure subWildCard;
  var
    str2, mask2: WideString;
  begin
    Inc(mi); // * XLbv

    tsi := si; tmi := mi;
    i := 0;
    while True do
    begin
      mi := tmi;
      si := tsi + i;

      str2  := Copy(FStr,  si, Length(FStr)  - si + 1);
      mask2 := Copy(FMask, mi, Length(FMask) - mi + 1);

      if MatchesMask2(str2, mask2) then
      begin
        Result := True; Exit;
      end;

      if si > Length(FStr) then
      begin
        Result := False;
        Exit;
      end;
      Inc(i);
    end;
  end;

begin
  // ftHǵATRUE
  Result := True;

  // ꂼ INDEX ɂP𓾂
  if si <= Length(FStr)  then ss := FStr[si]  else ss := #0;
  if mi <= Length(FMask) then ms := FMask[mi] else ms := #0;

  // vĂ邩H
  if ss=ms then // Equal
  begin
    Next; Exit;
  end;

  if ms='?' then // ?
  begin
    Next; Exit;
  end;

  if ms='*' then // *
  begin
    subWildCard; Exit;
  end;

  Result := False;
end;

function TEasyMask.Match: Boolean;
begin
  si := 1;
  mi := 1;
  Result := SubMatch;
end;

function TEasyMask.SubMatch: Boolean;
begin
  Result := True;

  while (Result) do
  begin
    if (mi > Length(FMask)) and (si > Length(FStr)) then
    begin
      Break;
    end;
    Result := CheckChar;
  end;
end;


function MatchesMask(const FileName, Masks: string) : Boolean;
var m: TEasyMask;
begin
    m := TEasyMask.Create ;
    try
        m.FStr  := FileName;
        m.FMask := Masks;

        m.FStr  := UpperCase(m.FStr);
        m.FMask := UpperCase(m.FMask);
        Result  := m.Match ;
    finally
        m.Free ;
    end;
end;

end.
